.686			
.mmx			
;k3d			
;.xmm			
.XMM
.model	flat, stdcall	 
option	casemap:none, language:stdcall, dotname
assume 	fs:nothing


include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\masm32.inc
include c:\masm32\include\msvcrt.inc
include c:\masm32\macros\macros.asm
include c:\masm32\macros\timers.asm
include CpuId.inc

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\masm32.lib
includelib c:\masm32\lib\msvcrt.lib


Main        proto

FJT2 proto
FJT3 proto
FJT4 proto
BMLin12 proto	:DWORD, :DWORD,:DWORD
.data

align 4

  LOOP_COUNT    EQU	500000
  MINUS_1       EQU 0ffffffffH

  SzBMI1         db "FJT2 Cresta/IanB, byte-length shifts:  ",0
  SzBMI2         db "FJT3 Cresta/IanB, word-length shifts:  ",0
  SzBMI3         db "FJT4 Cresta/IanB, dword-length shifts: ",0
  SzLingo        db "Boyer-Moore Lingo,dword-length shifts: ",0

  ; matchlen 10, sourcelen 50
  ; with optimisations, the Boyer-Moore is now only half as slow as the
  ; word scanner for short searches
    SzTest1        db "Short test with match string at end: Here it is!",13,10,0
    SzMatch1       db "Here it is",0  
    SzResult1      db 13,10,"Search Test 1 - value expected 37",13,10,0

  ; matchlen 17, sourcelen 1024
  ; deliberately difficult, every position must be tested with this match start
  SzTest2        db 1007 dup ("M"), "MMMMMMhardMMMMMMM", 0
  SzMatch2       db "MMMMMMhardMMMMMMM",0  
  SzResult2      db 13,10,"Search Test 2 - value expected 1007",13,10,0

  ; matchlen 16, sourcelen 1024
  ; pattern very different from background
  SzTest3        db 1008 dup ("M"), "Should be easier", 0
  SzMatch3       db "Should be easier",0  
  SzResult3      db 13,10,"Search Test 3 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch seems to have advantage for longer match lengths 
  SzTest4        db 72 dup ("Many repetitio"), "Many repetitions", 0
  SzMatch4       db "Many repetitions"  
  SzResult4      db 13,10,"Search Test 4 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch can't seem to take advantage of the earlier match failure 
  SzTest5        db 72 dup ("Many repeatsns"), "Many repetitions", 0
  SzMatch5       db "Many repetitions"  
  SzResult5      db 13,10,"Search Test 5 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; serious disadvantage for Boyer-Moore for this close repeating pattern
  ; as all the repeats must check from the matching end almost to the start
  SzTest6        db 72 dup ("No repetitions"), "Many repetitions", 0
  SzMatch6       db "Many repetitions"  
  SzResult6      db 13,10,"Search Test 6 - value expected 1008",13,10,0

  ; matchlen 14, sourcelen 1024
  ; more random text, BInStrWithLen catching up with Boyer-Moore
  SzTest7        db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, few or no repetitions", 0
SzMatch7       db "no repetitions",0  
SzResult7      db 13,10,"Search Test 7 - value expected 1009",13,10,0

.data?
align 16
tabl qword  64*16 Dup(?)
align 16

  ShiftTable     DWORD 256 DUP (?)

.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc


	invoke ShowCPU, 1
    print   chr$(13,10,13,10)

        push    ebx
        push    edi
        mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$(13,10,13,10,"String search tests:",13,10,13,10)


        print   addr SzResult1

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	  print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
;        mov     eax, 10  ; matchlen
;        mov     edx, 50  ; sourcelen
;        lea     ecx, SzMatch1
;        lea     ebp, SzTest1
;        xor     ebx, ebx ; startpos
;db 0cch

        invoke  BMLin12, addr SzTest1, addr SzMatch1, 10  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzResult2

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLin12, addr SzTest2, addr SzMatch2, 17  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzResult3

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLin12, addr SzTest3, addr SzMatch3, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzResult4

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLin12, addr SzTest4, addr SzMatch4, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250




        print   addr SzResult5

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLin12, addr SzTest5, addr SzMatch5, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250










        print   addr SzResult6

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLin12, addr SzTest6, addr SzMatch6, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250





        print   addr SzResult7

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLin12, addr SzTest7, addr SzMatch7, 14  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250


        mov     eax, input(" Press ENTER to exit...")
        pop     edi
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

align 16

FJT2	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 255 chars, allowing byte-length shifts and a 256-byte shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 255)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 254                ; string too long, must be < 254
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosb                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     BYTE PTR ShiftTable[ecx], al
        sub     al, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, BYTE PTR ShiftTable[ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT2 endp

; ------------------------------------------------------------------------------

align 16

FJT3	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 64K chars, allowing word-length shifts and a 256-word shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 65535)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 65534              ; string too long, must be < 65535
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosw                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     WORD PTR ShiftTable[ecx+ecx], ax
        sub     ax, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, WORD PTR ShiftTable[ecx+ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT3 endp

; ------------------------------------------------------------------------------

align 16

FJT4	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Full 4Gb string length searches
            possible with a DWORD-sized shift table.

            On entry:
                EAX = match_len (must be >= 2)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, MINUS_1            ; string too long, must be < 4Gb-1
        je      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosd                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     ShiftTable[ecx*4], eax
        sub     eax, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        mov     ecx, ShiftTable[ecx*4]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT4 endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

;------------------------------------------------------------------------	;
;________________________________________________	;
comment	* BM by Lingo *			
option		prologue:none						; turn it off
option		epilogue:none							
align 			16		
db				8		Dup(9h)
BMLin12			proc	lpBuffer:dword, lpSrchPatt:dword, lenSrchPatt:dword
	pop				edx									; return address
	movd			MM2, edi
	pop				eax									; eax->lpBuffer ; ecx->lenSrchPattern
	movd			MM3, esi
	pop				esi									; esi->lpSrchPatt
	movd			MM4, ebx
	pop				ecx									; ecx->lenSrchPattern ;  must be greater than 8!!!
	movd			MM5, ebp
	lea				ebp,		[ecx+1-4]				; ebp->lenSrchPatt -3
	movd			MM1, esp
	movd			xmm0,	ebp						;  
	mov				ebx,	[esi]							; ebx->first dword of the SrchPattern
	mov				esp, eax
	pshufd 			xmm0,	xmm0, 0				; 
	mov				ebp, [esi+ecx-4]				; ebp->last dword of the Search Pattern
	xor				edx,	edx							; edx=0
	movdqa		oword ptr [tabl+  0*16], xmm0			; xmm0= lenSrchPattern -3
	movdqa		oword ptr [tabl+  1*16], xmm0
	movdqa		oword ptr [tabl+  2*16], xmm0
	movdqa		oword ptr [tabl+  3*16], xmm0
	movdqa		oword ptr [tabl+  4*16], xmm0
	movdqa		oword ptr [tabl+  5*16], xmm0
	movdqa		oword ptr [tabl+  6*16], xmm0
	movdqa		oword ptr [tabl+  7*16], xmm0
	movdqa		oword ptr [tabl+  8*16], xmm0
	movdqa		oword ptr [tabl+  9*16], xmm0
	movdqa		oword ptr [tabl+10*16], xmm0
	movdqa		oword ptr [tabl+11*16], xmm0
	movdqa		oword ptr [tabl+12*16], xmm0
	movdqa		oword ptr [tabl+13*16], xmm0
	movdqa		oword ptr [tabl+14*16], xmm0
	movdqa		oword ptr [tabl+15*16], xmm0
	movdqa		oword ptr [tabl+16*16], xmm0
	movdqa		oword ptr [tabl+17*16], xmm0
	movdqa		oword ptr [tabl+18*16], xmm0
	movdqa		oword ptr [tabl+19*16], xmm0
	movdqa		oword ptr [tabl+20*16], xmm0
	movdqa		oword ptr [tabl+21*16], xmm0
	movdqa		oword ptr [tabl+22*16], xmm0
	movdqa		oword ptr [tabl+23*16], xmm0
	movdqa		oword ptr [tabl+24*16], xmm0
	movdqa		oword ptr [tabl+25*16], xmm0
	movdqa		oword ptr [tabl+26*16], xmm0
	movdqa		oword ptr [tabl+27*16], xmm0
	movdqa		oword ptr [tabl+28*16], xmm0
	movdqa		oword ptr [tabl+29*16], xmm0
	movdqa		oword ptr [tabl+30*16], xmm0
	movdqa		oword ptr [tabl+31*16], xmm0
	movdqa		oword ptr [tabl+32*16], xmm0
	movdqa		oword ptr [tabl+33*16], xmm0
	movdqa		oword ptr [tabl+34*16], xmm0
	movdqa		oword ptr [tabl+35*16], xmm0
	movdqa		oword ptr [tabl+36*16], xmm0
	movdqa		oword ptr [tabl+37*16], xmm0
	movdqa		oword ptr [tabl+38*16], xmm0
	movdqa		oword ptr [tabl+39*16], xmm0
	movdqa		oword ptr [tabl+40*16], xmm0
	movdqa		oword ptr [tabl+41*16], xmm0
	movdqa		oword ptr [tabl+42*16], xmm0
	movdqa		oword ptr [tabl+43*16], xmm0
	movdqa		oword ptr [tabl+44*16], xmm0
	movdqa		oword ptr [tabl+45*16], xmm0
	movdqa		oword ptr [tabl+46*16], xmm0
	movdqa		oword ptr [tabl+47*16], xmm0
	movdqa		oword ptr [tabl+48*16], xmm0
	movdqa		oword ptr [tabl+49*16], xmm0
	movdqa		oword ptr [tabl+50*16], xmm0
	movdqa		oword ptr [tabl+51*16], xmm0
	movdqa		oword ptr [tabl+52*16], xmm0
	movdqa		oword ptr [tabl+53*16], xmm0
	movdqa		oword ptr [tabl+54*16], xmm0
	movdqa		oword ptr [tabl+55*16], xmm0
	movdqa		oword ptr [tabl+56*16], xmm0
	movdqa		oword ptr [tabl+57*16], xmm0
	movdqa		oword ptr [tabl+58*16], xmm0
	movdqa		oword ptr [tabl+59*16], xmm0
	movdqa		oword ptr [tabl+60*16], xmm0
	movdqa		oword ptr [tabl+61*16], xmm0
	movdqa		oword ptr [tabl+62*16], xmm0
	movdqa		oword ptr [tabl+63*16], xmm0
@@:
	movzx			eax,	byte ptr [esi+edx]			; esi->address of the SrchPattern 
	add				edx,	1										; edx->counter 
	sub				ecx,	4
	mov				dword ptr [tabl+eax*4], ecx	; ecx-> lenSrchPattern-4
	add				ecx,	3		 
	jne				@b			 
	movzx			eax,	byte ptr [esp+edx]
	pop				ecx
	cmp				ecx,	ebx
	je					@f		
BM_Loop:												
	add				esp,	dword	ptr [tabl+eax*4]
	movzx			eax,	byte		ptr [esp+edx]
	pop				ecx
	cmp				ecx,	ebx
	jne				BM_Loop
@@:
	cmp				ebp,	[esp+edx-8]	        			;	ebp->last dword of the SrchPattern
	jne				BM_Loop			
	mov				edi,	[edx+esi-8] 
	db				2Eh											; cs:
	lea				ecx,	[edx-8]	
	cmp     			[ecx+esp-4],	edi 
	jne				BM_Loop
@@:
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	je					@b
align 16
@@:		
	cmp				esp,	esi						; esi-> address of the SrchPattern(after end of the buffer)
	lea				ecx,	[esp-4]					; esp-> current offset in the buffer
	sbb				eax,	eax
	movd			esp,	MM1					; restore registers
	movd			edi,	MM2
	movd			esi,	MM3
	movd			ebx,	MM4
	movd			ebp,	MM5
	sub				ecx,	[esp-3*4]				; [esp-3*4] -> lpBuffer
	and				eax,	ecx						; eax= offset in the buffer or zero	
	jmp	 			dword ptr [esp-4*4]		; jmp to return address
BMLin12		endp			
option		prologue:prologuedef	; turn back on the defaults
option		epilogue:epiloguedef	;
;___________________________	;

End	Start

